   MODULE mod_declarate

      USE mod_kind

      IMPLICIT NONE

   ! Das n wird gebraucht
   INTEGER , PARAMETER ::  n = 3

   !--- Input (namelist?)

   !- General run parameters

   ! Time steps per tidal period
   INTEGER :: itsper

   ! Tidal angular velocity in radian
   REAL (KIND=wp)  :: ometid
   ! Tidal period
   REAL (KIND=wp)  :: tidper
   ! Time step
   REAL (KIND=wp)  :: delt
   ! Number of degrees of latitude for polar cap

   ! dimension nper(3),npar(3),npaa(3),npae(3)  WAS HEISST DAS ??
   INTEGER , PARAMETER :: ncap = 1._wp    !=1._wp STIMMT NICHT !!
   ! Number of periods with fast diagnostics (n=1)
   ! Number of periods with full diagnostics (n=2)
   ! Number of storage periods (n=3)
   INTEGER , DIMENSION(1:n) :: nper
   ! Partition of periods
   INTEGER , DIMENSION(1:n) :: npar
   ! First partition to be calculated
   INTEGER , DIMENSION(1:n) :: npaa
   ! Last partition to be calculated
   INTEGER , DIMENSION(1:n) :: npae
   ! Comprehensive diagnostics every itbil timesteps
   INTEGER , PARAMETER :: itbil = 1  !Isses integer? initialisierung ausgedacht damits kompiliert
   ! Phases and amplitudes are calculated
   LOGICAL pham

   !-Iteration parameters

   ! fiap * zeta taken as first guess for the iteration
   INTEGER   :: fiap
   ! Number of iteration to be performed before convergenceis checked
   INTEGER   :: mxscan
   ! Maximum number of convergence checks
   INTEGER   :: mpscan
   ! Criterion to stop the iteration
   ! Keine Ahnung :: crit

   REAL (KIND=wp) :: resmap

   !-Frictional coefficients

   ! Coefficient of quadratic bottom-friction
   !REAL (KIND=wp) , PARAMETER :: bofr
   ! Maximum coefficient of eddy-viscosity
   !REAL (KIND=wp) , PARAMTER  :: amh

   !-Tidal coefficients

   ! Tidal angular velocity in degrees per hour
   REAL(KIND=wp) :: degpeh
   ! Doodson's k-factor for the partial tides
   REAL(KIND=wp) :: amptid
   !Coefficient for parametrization of perturbation potentials
   REAL(KIND=wp) :: tlosa
   ! =1 for diurnal, =2 for semi-diurnal tides, =3 for long-period tides
   INTEGER       :: itide


   !--- Grid constants
   REAL (KIND=wp) , PARAMETER :: pi     = 3.141592653589793
   REAL (KIND=wp) , PARAMETER :: radius = 6371.e+05_wp
   REAL (KIND=wp) , PARAMETER :: radian = pi/180._wp
   REAL (KIND=wp) , PARAMETER :: dxdeg  = 1._wp
   REAL (KIND=wp) , PARAMETER :: dydeg  = 1._wp
   REAL (KIND=wp) , PARAMETER :: zweipi = 2._wp * pi
   REAL (KIND=wp) , PARAMETER :: omecor = zweipi/43082._wp
   REAL (KIND=wp) , PARAMETER :: dx     = dxdeg * radius * radian
   REAL (KIND=wp) , PARAMETER :: dxr    = 1._wp / dx
   REAL (KIND=wp) , PARAMETER :: dx2r   = 0.5_wp * dxr
   REAL (KIND=wp) , PARAMETER :: dxrq   = dxr * dxr
   REAL (KIND=wp) , PARAMETER :: dy     = dydeg * radius * radian
   REAL (KIND=wp) , PARAMETER :: dyr    = 1._wp / dy
   REAL (KIND=wp) , PARAMETER :: dy2r   = 0.5_wp * dyr
   REAL (KIND=wp) , PARAMETER :: dyrq   = dyr * dyr
   REAL (KIND=wp) , PARAMETER :: dysdeg = ncap * dydeg  ! REAL(ncap)
   REAL (KIND=wp) , PARAMETER :: dys    = dysdeg * radian

   REAL (KIND=wp) , PARAMETER :: polar  = zweipi * radius * radius * (1._wp - cos(dys))


   INTEGER        , PARAMETER :: lamz   = 180
   INTEGER        , PARAMETER :: lamu   = lamz - 1
   INTEGER        , PARAMETER :: lamup  = lamu + 1
   INTEGER        , PARAMETER :: lamv   = lamz
   INTEGER        , PARAMETER :: lamvp  = lamv + 1
   INTEGER        , PARAMETER :: lateu  = lamz/2
   INTEGER        , PARAMETER :: latev  = lateu+1
   INTEGER        , PARAMETER :: longs  = 360
   INTEGER        , PARAMETER :: lonh   = longs/2
   INTEGER        , PARAMETER :: lonv   = longs/4
   INTEGER        , PARAMETER :: lafi   = 1
   INTEGER        , PARAMETER :: lafip  = lafi + 1
   INTEGER        , PARAMETER :: nlove  = 1
   INTEGER        , PARAMETER :: longp  = longs + 1
   INTEGER        , PARAMETER :: nener  = 3
   INTEGER        , PARAMETER :: nteam  = 9
   INTEGER        , PARAMETER :: nteen  = 4
   INTEGER        , PARAMETER :: ntoi   = 6
   INTEGER        , PARAMETER :: icomp  = 3

   INTEGER        , PARAMETER :: latz   = lamz - ncap + 1
   INTEGER        , PARAMETER :: latu   = latz - 1
   INTEGER        , PARAMETER :: latup  = latu + 1
   INTEGER        , PARAMETER :: latv   = latz
   INTEGER        , PARAMETER :: latvp  = latv + 1
   !--- Grid variables
   REAL (KIND=wp) :: phi
   REAL (KIND=wp) :: glon
   REAL (KIND=wp) , DIMENSION(1:lamz)  :: cosu, sinu
   REAL (KIND=wp) , DIMENSION(1:lamz)  :: cosur
   REAL (KIND=wp) , DIMENSION(1:latev) :: cosv, cosvr, sinv
   REAL (KIND=wp) , DIMENSION(1:longs) :: acsul, asnul
   REAL (KIND=wp) , DIMENSION(1:longs) :: acsvl, asnvl
   REAL (KIND=wp) , DIMENSION(1:lamz)  :: fxcs, fycs
   REAL (KIND=wp) , DIMENSION(1:lamz)  :: gus, gun, gvn, gvs
   REAL (KIND=wp) , DIMENSION(1:lamz)  :: acc, ass, acs
   REAL (KIND=wp) , DIMENSION(1:longs) :: cosul, sinul
   REAL (KIND=wp) , DIMENSION(1:longs) :: cosvl, sinvl

   REAL (KIND=wp) , DIMENSION(1:2,1:nlove) :: love !
   data love /0.302, 0.612 /
                                          !olove(1) = 0.302
                                          !love(2) = 0.612

   !--- workspace
   INTEGER , DIMENSION(0:longp, lafi:lamu)  :: ua
   INTEGER , DIMENSION(0:longp, lafip:lamv) :: va
   INTEGER , DIMENSION(0:longp, lafi:lamu)  :: fxn
   INTEGER , DIMENSION(0:longp, lafip:lamv) :: fyn

   !-topogr

   REAL (KIND=wp) , DIMENSION(0:longp, lafi:lamz) :: dep

   !-fields

   REAL (KIND=wp) , DIMENSION(0:longp, lafi:lamz)   :: zeta
   REAL (KIND=wp) , DIMENSION(0:longp, lafi:lamup)  :: u
   REAL (KIND=wp) , DIMENSION(0:longp, lafip:lamvp) :: v

   !-budget (MUSS DOUBLE SEIN)

   REAL (KIND=dp) , DIMENSION(1:nener)  :: buen, buenp
   REAL (KIND=dp) , DIMENSION(1:nteen)  :: baen, baenp
   REAL (KIND=dp) , DIMENSION(1:icomp)  :: buamr, buamrp
   REAL (KIND=dp) , DIMENSION(1:ntoi)   :: butoi, butoip
   REAL (KIND=dp) , DIMENSION(1:icomp)  :: bumor, bumorp
   REAL (KIND=dp) , DIMENSION(1:icomp)  :: bucom, bucomp
   REAL (KIND=dp) , DIMENSION(1:icomp)  :: buama, buamap
   REAL (KIND=dp) , DIMENSION(1:nteam, 1:icomp)  :: baam, baamp
   REAL (KIND=dp) :: chovop, chovoi

   !-relcoe

   REAL (KIND=wp) , DIMENSION(0:longp, lafi:lamz) :: zetaa
   REAL (KIND=wp) , DIMENSION(0:longp, lafi:lamz) :: res





   !--- Help variables
   INTEGER :: j
   INTEGER :: i
   INTEGER :: ish
   REAL (KIND=wp) :: fxc
   REAL (KIND=wp) :: fyc
   !- wohin damit ? was ist das ? stimmt der typ ?
   INTEGER :: itpar
   INTEGER :: npe
   INTEGER :: npa
   INTEGER :: ita
   INTEGER :: ite
   INTEGER :: itt
   INTEGER :: iun

   INTEGER :: iqu
   INTEGER :: npr
   INTEGER :: nprs
   REAL (KIND=wp) :: simtim
   REAL (KIND=wp) :: phaset

   END MODULE
