

program globe
	parameter (lafi =1     ,lafip=lafi+1 ,lamz =180    ,
     *           lamv =lamz   ,lamvp=lamv+1 ,lamu =lamz-1 ,
     *           lamup=lamu+1 ,lateu=lamz/2 ,latev=lateu+1,
     *           lseg =22     ,nlove=1      ,longs=360    ,
     *           longp=longs+1,lonh =longs/2,lonv =longs/4,
     *           nener=3      ,nteam=9      ,nteen=4      ,
     *           ntoi =6      ,icomp=3                    )
	common / grid /
     * ncap,latz,latu,latv,latup,latvp,
     * dxdeg,dx,dxr,dx2r,dxrq,dydeg,dy,dyr,dy2r,dyrq,dysdeg,dys,
     * cosu  (lamz),cosv  (lamz),cosur (lamz),cosvr (lamz),
     * sinu  (lamz),sinv  (lamz),fxcs  (lamz),fycs  (lamz),
     * gus   (lamz),gun   (lamz),gvn   (lamz),gvs   (lamz),
     * cosul(longs),sinul(longs),cosvl(longs),sinvl(longs),
     * acsul(longs),asnul(longs),acsvl(longs),asnvl(longs),
     * acc  (longs),ass  (longs),acs  (longs)
	real love(2,nlove)
	common / scalar / delt  ,grav  ,omecor,ometid,phaset,
     *                  amptid,love  ,tlosa ,bofr  ,amh   ,
     *                  crit  ,mxscan,mpscan,fiap  ,resmap,
     *                  itt   ,itsper,itide ,radius,radiur,
     *                  pi    ,zweipi,polar ,pole  ,radian,
     *                  frb   ,fxg   ,fyg
	data love /0.302,0.612/
	common / topogr /
     * isz(lseg,lafi :lamz),iez(lseg,lafi :lamz),
     * isu(lseg,lafi :lamu),ieu(lseg,lafi :lamu),
     * isv(lseg,lafip:lamv),iev(lseg,lafip:lamv),
     * dep(0:longp,lafi:lamz)
	common / fields /
     * zeta(0:longp,lafi:lamz ),
     * u   (0:longp,lafi:lamup),v(0:longp,lafip:lamvp)
	double precision buen  ,baen  ,buamr ,baam  ,chovoi
	double precision buenp ,baenp ,buamrp,baamp ,chovop
	double precision buama ,bumor ,bucom ,butoi
	double precision buamap,bumorp,bucomp,butoip
	common / budget /
     * buen (nener),buenp (nener),baen (nteen),baenp (nteen),
     * buamr(icomp),buamrp(icomp),butoi(ntoi ),butoip(ntoi ),
     * bumor(icomp),bumorp(icomp),bucom(icomp),bucomp(icomp),
     * buama(icomp),buamap(icomp),chovoi,chovop,
     * baam (nteam,icomp),baamp(nteam,icomp)
	common / relcoe / zetaa(0:longp,lafi:lamz),
     *                  cfn  (0:longp,lafi:lamu),
     *                  cfs  (0:longp,lafi:lamz),
     *                  cfe  (0:longp,lafi:lamu),
     *                  cfw  (0:longp,lafi:lamu),
     *                  rhsi (0:longp,lafi:lamz),
     *                  res  (0:longp,lafi:lamz)
	common / worksp /
     *  ua (0:longp,lafi:lamu),va (0:longp,lafip:lamv),
     *  fxn(0:longp,lafi:lamu),fyn(0:longp,lafip:lamv)
	dimension nper(3),npar(3),npaa(3),npae(3)
	logical pham
	namelist /contrl/ nper  ,npar  ,npaa  ,npae  ,
     *                  itsper,itbil ,pham  ,ncap  ,
     *                  mxscan,mpscan,crit  ,fiap  ,
     *                  bofr  ,amh   ,degpeh,amptid,
     *                  itide ,tlosa
c
c initializing routine for global semi-implicit tidal ocean model.
c
c meaning of namelist-parameters
c
c *** general run parameters
c     nper(n): number of periods with fast diagnostics  n = 1
c              number of periods with full diagnostics  n = 2
c              number of storage periods                n = 3
c     npar(n): partition of periods
c     npaa(n): first partition to be calculated
c     npae(n): last  partition to be calculated
c     itsper : number of timesteps per tidal period
c     itbil  : comprehensive diagnostics every itbil timesteps
c     pham   : phases and amplitudes are calculated  (if n=2)
c     ncap   : number of degrees of latitude for polar cap
c *** iteration parameters
c     fiap   : fiap*zeta is taken as first guess for the iteration
c     mxscan : number of iterations to be performed before convergence
c              is checked
c     mpscan : maximum number of convergence checks
c     crit   : criterion to stop the iteration
c *** frictional coefficients
c     bofr   : coefficient of quadratic bottom-friction
c     amh    : maximum coefficient of eddy-viscosity
c *** tidal coefficients
c     tlosa  : coefficient for parametrization of perturbation potentials
c     degpeh : tidal frequency in degrees per hour
c     amptid : doodsons k-factor for the partial tide
c     itide  : = 1 for diurnal, = 2 for semi-diurnal tides,
c              = 3 for long-period tides
c
c read run parameters from namelist "contrl" and read initial data
c
	read (5,contrl)
	buffer in (30,1) (isz(1,lafi),dep(longp,lamz))
	buffer in (31,1) (zeta(0,lafi),zeta(longp,lamz))
	buffer in (32,1) (u(0,lafi),u(longp,lamu))
	buffer in (33,1) (v(0,lafip),v(longp,lamv))
	buffer in (34,1) (buen(1),baamp(nteam,icomp))
c
c calculate some constants
c
	pi     = 3.141592653589793
	zweipi = 2.*pi
	radian = pi/180.
	omecor = zweipi/43082.
	radius = 6371.e+05
	radiur = 1./radius
	grav   = 980.6
	dxdeg  = 1.
	dydeg  = 1.
	dx     = dxdeg*radius*radian
	dxr    = 1./dx
	dx2r   = 0.5*dxr
	dxrq   = dxr*dxr
	dy     = dydeg*radius*radian
	dyr    = 1./dy
	dy2r   = 0.5*dyr
	dyrq   = dyr*dyr
	dysdeg = real(ncap)*dydeg
	dys    = dysdeg*radian
	polar  = zweipi*radius*radius*(1.-cos(dys))
	ticons = 7.61e-08*grav/0.90812
	ometid = degpeh*radian/3600.
	tidper = zweipi/ometid
	delt   = tidper/real(itsper)
	pole   = sin(dys)*dx*delt/polar
	equel  = 0.5*radius*ticons*amptid/grav
	regrad = grav*delt*(1.-tlosa)
	fxg    = regrad*dx2r
	fyg    = regrad*dy2r
	frb    = bofr*delt
	write(6,contrl)
	amptid = -(1.+love(1,1)-love(2,1))*amptid*ticons
	latz   = lamz-ncap+1
	latu   = latz-1
	latup  = latu+1
	latv   = latz
	latvp  = latv+1
	write(6,1010) ometid,tidper,equel,delt
c
c sine and cosine at latitudes
c
	phi = 0.5*dydeg*radian
	do 10 j=lateu+1,lamv
	  cosu (j)        =  cos(phi)
	  sinu (j)        =  sin(phi)
	  cosu (lamu+2-j) =  cosu(j)
	  sinu (lamu+2-j) = -sinu(j)
	  cosur(j)        =  1./cosu(j)
	  cosur(lamu+2-j) =  cosur(j)
	  phi             =  phi+radian*dydeg
   10 continue
	cosv (latev) = 1.
	cosvr(latev) = 1.
	sinv (latev) = 0.
	phi          = dydeg*radian
	do 15 j=latev+1,lamv
	  cosv (j)        =  cos(phi)
	  sinv (j)        =  sin(phi)
	  cosv (lamv+2-j) =  cosv(j)
	  sinv (lamv+2-j) = -sinv(j)
	  cosvr(j)        =  1./cosv(j)
	  cosvr(lamv+2-j) =  cosvr(j)
	  phi             =  phi+radian*dydeg
   15 continue
c
c weighting coefficients for interpolation of quantities
c
CDIR$ SHORTLOOP
	do 20 j=1,lafi
	  gun(j) = 0.
	  gus(j) = 0.
	  gvn(j) = 0.
	  gvs(j) = 0.
   20 continue
	do 25 j=lafi,lamu
	  gus(j) = cosv(j  )*cosur(j)
	  gun(j) = cosv(j+1)*cosur(j)
   25 continue
	gus(lafi) = 0.
	gun(lamv) = 0.
	gus(lamv) = 0.
	do 30 j=lafip,lamv
	  gvs(j) = cosu(j-1)*cosvr(j)
	  gvn(j) = cosu(j  )*cosvr(j)
   30 continue
c
c coriolis-operator
c
	do 35 j=lafi,lamu
	  fxc     = omecor*sinu(j)
	  fxcs(j) = sin(fxc*delt)/delt
   35 continue
	do 40 j=lafip,lamv
	  fyc     = omecor*sinv(j)
	  fycs(j) = sin(fyc*delt)/delt
   40 continue
c
c sine and cosine at longitudes
c
	do 45 i=1,lonv-1
	  glon = real(i)*dxdeg*radian
	  cosul(i     ) =  cos(glon)
	  sinul(i     ) =  sin(glon)
	  cosul(lonh-i) = -cosul(i)
	  sinul(lonh-i) =  sinul(i)
   45 continue
	cosul(lonv) =  0.
	sinul(lonv) =  1.
	cosul(lonh) = -1.
	sinul(lonh) =  0.
	do 50 i=lonh+1,longs-1
	  cosul(i) =  cosul(longs-i)
	  sinul(i) = -sinul(longs-i)
   50 continue
	cosul(longs) = 1.
	sinul(longs) = 0.
	do 55 i=1,longs-20
	  ish = i+20
	  acsul(i) = cosul(ish)
	  asnul(i) = sinul(ish)
   55 continue
CDIR$ SHORTLOOP
	do 60 i=longs-19,longs
	  ish = i-longs+20
	  acsul(i) = cosul(ish)
	  asnul(i) = sinul(ish)
   60 continue
	do 65 i=1,lonh-10
	  cosul(i     ) = acsul(2*i+20)
	  sinul(i     ) = asnul(2*i+20)
	  cosul(i+lonh) = cosul(i)
	  sinul(i+lonh) = sinul(i)
   65 continue
	do 66 i=lonh-9,lonh
	  cosul(i     ) = acsul(2*i+20-longs)
	  sinul(i     ) = asnul(2*i+20-longs)
	  cosul(i+lonh) = cosul(i)
	  sinul(i+lonh) = sinul(i)
   66 continue
	do 70 i=1,lonv
	  glon = (real(i)-0.5)*dxdeg*radian
	  cosvl(i       ) =  cos(glon)
	  sinvl(i       ) =  sin(glon)
	  cosvl(lonh+1-i) = -cosvl(i)
	  sinvl(lonh+1-i) =  sinvl(i)
   70 continue
	do 75 i=lonh+1,longs
	  cosvl(i) =  cosvl(longs+1-i)
	  sinvl(i) = -sinvl(longs+1-i)
   75 continue
	do 80 i=1,longs-20
	  ish = i+20
	  acsvl(i) = cosvl(ish)
	  asnvl(i) = sinvl(ish)
   80 continue
CDIR$ SHORTLOOP
	do 85 i=longs-19,longs
	  ish = i-longs+20
	  acsvl(i) = cosvl(ish)
	  asnvl(i) = sinvl(ish)
   85 continue
	do 90 i=1,lonh-10
	  cosvl(i     ) = acsul(2*i+19)
	  sinvl(i     ) = asnul(2*i+19)
	  cosvl(i+lonh) = cosvl(i)
	  sinvl(i+lonh) = sinvl(i)
   90 continue
	do 91 i=lonh-9,lonh
	  cosvl(i     ) = acsul(2*i+19-longs)
	  sinvl(i     ) = asnul(2*i+19-longs)
	  cosvl(i+lonh) = cosvl(i)
	  sinvl(i+lonh) = sinvl(i)
   91 continue
	do 95 i=1,longs
	  acc(i) = acsvl(i)*acsvl(i)
	  ass(i) = asnvl(i)*asnvl(i)
	  acs(i) = acsvl(i)*asnvl(i)
   95 continue
c
c complete reading of topography
c
	rsta = unit(30)
	if(rsta.gt.0.) then
	  write(6,'(23h input error on unit 30)')
	  stop
	endif
	close(30)
c
c complete reading of initial data: zeta
c
	rsta = unit(31)
	if(rsta.gt.0.) then
	  write(6,'(23h input error on unit 31)')
	  stop
	endif
	rewind 31
c
c calculate total depth at the beginning of a run
c
	res(:,:) = dep(:,:) + zeta(:,:)
c
c complete reading of initial data: velocities & budgets
c
	do 100 iun=32,34
	  rsta = unit(iun)
	  if(rsta.gt.0.) then
	    write(6,'(21h input error on unit ,i2)') iun
	    stop
	  endif
	  rewind iun
  100 continue
c
c begin timestepping
c
	write(6,1020)
c
c periods with fast diagnostics
c
	do 300 npe=1,nper(1)
	  itpar  = itsper/npar(1)
	  if(npaa(1).eq.1) then
	    resmap = -1.
	    chovop =  0.
CDIR$ SHORTLOOP
	    buenp (:) = 0.d0
CDIR$ SHORTLOOP
	    buamrp(:) = 0.d0
	  endif
	  do 250 npa=npaa(1),npae(1)
	    ita = (npa-1)*itpar
	    ite =  npa   *itpar-1
	    do 200 itt=ita,ite
		simtim = itt*delt
		phaset = ometid*simtim
		call step
c
c calculate bulk quantities
c
		res(:,:) = dep(:,:)+zetaa(:,:)
		call diagno(.true.)
c
c update variables
c
		zeta(:,:) = zetaa(:,:)
		do 190 j=lafi,latu
		  u(:,j  ) = ua(:,j  )
		  v(:,j+1) = va(:,j+1)
  190       continue
  200     continue
c
c save arrays at the end of each partition
c
	    buffer out (31,1) (zeta(0,lafi ),zeta (longp,lamz ))
	    buffer out (32,1) (u   (0,lafi ),u    (longp,lamu ))
	    buffer out (33,1) (v   (0,lafip),v    (longp,lamv ))
	    buffer out (34,1) (buen(1      ),baamp(nteam,icomp))
	    do 210 iun=31,34
		wsta = unit(iun)
		if(wsta.gt.0.) then
		  write(6,'(22h output error on unit ,i2)') iun
		  stop
		endif
		rewind iun
  210     continue
  250   continue
c
c output temporal mean bulk quantities
c
	  if(itt.eq.itsper) then
CDIR$ SHORTLOOP
	    buenp (:) = buenp (:)/dble(itsper)
CDIR$ SHORTLOOP
	    buamrp(:) = buamrp(:)/dble(itsper)
	    chovop    = chovop   /dble(itsper)
	    write(6,1030) buenp,buamrp,chovop,resmap
	  else
	    chovoi = dble(itpar*npae(1))
CDIR$ SHORTLOOP
	    buenp (:) = buenp (:)/chovoi
CDIR$ SHORTLOOP
	    buamrp(:) = buamrp(:)/chovoi
	    chovop    = chovop   /chovoi
	    write(6,1040)  npae(1),npar(1),buenp,buamrp,chovop,resmap
CDIR$ SHORTLOOP
	    buenp (:) = buenp (:)*chovoi
CDIR$ SHORTLOOP
	    buamrp(:) = buamrp(:)*chovoi
	    chovop    = chovop   *chovoi
	  endif
  300 continue
c
c periods with comprehensive diagnostics
c
	do 500 npe=1,nper(2)
	  itpar  = itsper/npar(2)
	  nprs   = npar(2)/4
	  if(npaa(2).eq.1) then
	    resmap = -1.
	    chovop =  0.
CDIR$ SHORTLOOP
	    buenp (:  ) = 0.d0
CDIR$ SHORTLOOP
	    baenp (:  ) = 0.d0
CDIR$ SHORTLOOP
	    baamp (:,:) = 0.d0
CDIR$ SHORTLOOP
	    buamrp(:  ) = 0.d0
CDIR$ SHORTLOOP
	    bumorp(:  ) = 0.d0
CDIR$ SHORTLOOP
	    bucomp(:  ) = 0.d0
CDIR$ SHORTLOOP
	    buamap(:  ) = 0.d0
CDIR$ SHORTLOOP
	    butoip(:  ) = 0.d0
	  endif
	  do 450 npa=npaa(2),npae(2)
	    iqu = npa/nprs
	    npr = mod(npa,nprs)
	    ita = (npa-1)*itpar
	    ite =  npa   *itpar-1
	    do 400 itt=ita,ite
		simtim = itt*delt
		phaset = ometid*simtim
		call step
c
c call diagnostic routine and output instantaneous bulk quantities
c
**********
		 if(mod(itt,itbil).eq.0) then
		  res(:,:) = dep(:,:)+zeta (:,:)
		  call bilanz
		  res(:,:) = dep(:,:)+zetaa(:,:)
		  call diagno(.false.)
c
c write instantaneous bulks to binary file
c
		  write(61) buen
		  write(61) buamr
		  write(61) buama
		  write(61) butoi
		  write(61) bucom
		  write(61) bumor
		  write(62) baen
		  write(63) baam
		else
		  res(:,:) = dep(:,:)+zetaa(:,:)
		endif
c
c update variables
c
		zeta(:,:) = zetaa(:,:)
		do 390 j=lafi,latu
		  u(:,j  ) = ua(:,j  )
		  v(:,j+1) = va(:,j+1)
  390       continue
  400     continue
c
c save arrays at the end of each partition
c
	    buffer out (31,1) (zeta(0,lafi ),zeta (longp,lamz ))
	    buffer out (32,1) (u   (0,lafi ),u    (longp,lamu ))
	    buffer out (33,1) (v   (0,lafip),v    (longp,lamv ))
	    buffer out (34,1) (buen(1      ),baamp(nteam,icomp))
	    wsta = unit(31)
	    if(wsta.gt.0.) then
		write(6,'(24h output error on unit 31)')
		stop
	    endif
	    rewind 31
	    if(pham.and.npr.eq.0) call result(iqu)
	    do 410 iun=32,34
		wsta = unit(iun)
		if(wsta.gt.0.) then
		  write(6,'(22h output error on unit ,i2)') iun
		  stop
		endif
		rewind iun
  410     continue
  450   continue
c
c output of temporal mean bulk quantities
c
	  if(itt.eq.itsper) then
	    chovoi = dble(itsper/itbil)
CDIR$ SHORTLOOP
	    buenp (:  ) = buenp (:  )/chovoi
CDIR$ SHORTLOOP
	    baenp (:  ) = baenp (:  )/chovoi
CDIR$ SHORTLOOP
	    baamp (:,:) = baamp (:,:)/chovoi
CDIR$ SHORTLOOP
	    buamrp(:  ) = buamrp(:  )/chovoi
CDIR$ SHORTLOOP
	    bumorp(:  ) = bumorp(:  )/chovoi
CDIR$ SHORTLOOP
	    bucomp(:  ) = bucomp(:  )/chovoi
CDIR$ SHORTLOOP
	    buamap(:  ) = buamap(:  )/chovoi
CDIR$ SHORTLOOP
	    butoip(:  ) = butoip(:  )/chovoi
	    chovop = chovop/chovoi
	    write(61) buenp
	    write(61) buamrp
	    write(61) buamap
	    write(61) butoip
	    write(61) bucomp
	    write(61) bumorp
	    write(62) baenp
	    write(63) baamp
	    write(6,1030) buenp,buamrp,chovop,resmap
	  else
	    chovoi = dble(itpar*npae(2)/itbil)
CDIR$ SHORTLOOP
	    buenp (:) = buenp (:)/chovoi
CDIR$ SHORTLOOP
	    buamrp(:) = buamrp(:)/chovoi
	    chovop    = chovop   /chovoi
	    write(6,1040)  npae(2),npar(2),buenp,buamrp,chovop,resmap
	    buenp (:) = buenp (:)*chovoi
CDIR$ SHORTLOOP
	    buamrp(:) = buamrp(:)*chovoi
CDIR$ SHORTLOOP
	    chovop    = chovop   *chovoi
	  endif
  500 continue
c
c perform a storage period
c
	do 700 npe=1,nper(3)
	  itpar  = itsper/npar(3)
	  do 650 npa=npaa(3),npae(3)
	    ita = (npa-1)*itpar
	    ite =  npa   *itpar-1
	    do 600 itt=ita,ite
		simtim = itt*delt
		phaset = ometid*simtim
		call step
c
c update variables
c
		zeta(:,:) = zetaa(:,:)
		res (:,:) = dep  (:,:)+zetaa(:,:)
		do 590 j=lafi,latu
		  u(:,j  ) = ua(:,j  )
		  v(:,j+1) = va(:,j+1)
  590       continue
  600     continue
	    call todisk
  650   continue
  700 continue
c
c finish program execution
c
 4000 stop 'bye'
 1010 format(/,' tidal frequency:',1pe12.5,' tidal period:',e12.5,
     *       ' equilibrium elevation;',0p,f9.5,' timestep:',f8.3)
 1020 format(8x,'  kin energy   pot energy   tot energy   ang mom x   an
     *g mom  y   ang mom  z   ch of vol     max res',/)
 1030 format(' t mean ',1p,8(1x,e12.5))
 1040 format(1x,i3,'/',i3,1p,8(1x,e12.5))
	end
	subroutine step
	parameter (lafi =1     ,lafip=lafi+1 ,lamz =180    ,
     *           lamv =lamz   ,lamvp=lamv+1 ,lamu =lamz-1 ,
     *           lamup=lamu+1 ,lateu=lamz/2 ,latev=lateu+1,
     *           lseg =22     ,nlove=1      ,longs=360    ,
     *           longp=longs+1,lonh =longs/2,lonv =longs/4,
     *           nener=3      ,nteam=9      ,nteen=4      ,
     *           ntoi =6      ,icomp=3                    )
	common / grid /
     * ncap,latz,latu,latv,latup,latvp,
     * dxdeg,dx,dxr,dx2r,dxrq,dydeg,dy,dyr,dy2r,dyrq,dysdeg,dys,
     * cosu  (lamz),cosv  (lamz),cosur (lamz),cosvr (lamz),
     * sinu  (lamz),sinv  (lamz),fxcs  (lamz),fycs  (lamz),
     * gus   (lamz),gun   (lamz),gvn   (lamz),gvs   (lamz),
     * cosul(longs),sinul(longs),cosvl(longs),sinvl(longs),
     * acsul(longs),asnul(longs),acsvl(longs),asnvl(longs),
     * acc  (longs),ass  (longs),acs  (longs)
	real love(2,nlove)
	common / scalar / delt  ,grav  ,omecor,ometid,phaset,
     *                  amptid,love  ,tlosa ,bofr  ,amh   ,
     *                  crit  ,mxscan,mpscan,fiap  ,resmap,
     *                  itt   ,itsper,itide ,radius,radiur,
     *                  pi    ,zweipi,polar ,pole  ,radian,
     *                  frb   ,fxg   ,fyg
	data love /0.302,0.612/
	common / topogr /
     * isz(lseg,lafi :lamz),iez(lseg,lafi :lamz),
     * isu(lseg,lafi :lamu),ieu(lseg,lafi :lamu),
     * isv(lseg,lafip:lamv),iev(lseg,lafip:lamv),
     * dep(0:longp,lafi:lamz)
	common / fields /
     * zeta(0:longp,lafi:lamz ),
     * u   (0:longp,lafi:lamup),v(0:longp,lafip:lamvp)
	double precision buen  ,baen  ,buamr ,baam  ,chovoi
	double precision buenp ,baenp ,buamrp,baamp ,chovop
	double precision buama ,bumor ,bucom ,butoi
	double precision buamap,bumorp,bucomp,butoip
	common / budget /
     * buen (nener),buenp (nener),baen (nteen),baenp (nteen),
     * buamr(icomp),buamrp(icomp),butoi(ntoi ),butoip(ntoi ),
     * bumor(icomp),bumorp(icomp),bucom(icomp),bucomp(icomp),
     * buama(icomp),buamap(icomp),chovoi,chovop,
     * baam (nteam,icomp),baamp(nteam,icomp)
	common / relcoe / zetaa(0:longp,lafi:lamz),
     *                  cfn  (0:longp,lafi:lamu),
     *                  cfs  (0:longp,lafi:lamz),
     *                  cfe  (0:longp,lafi:lamu),
     *                  cfw  (0:longp,lafi:lamu),
     *                  rhsi (0:longp,lafi:lamz),
     *                  res  (0:longp,lafi:lamz)
	common / worksp /
     *  ua (0:longp,lafi:lamu),va (0:longp,lafip:lamv),
     *  fxn(0:longp,lafi:lamu),fyn(0:longp,lafip:lamv)
c
c timestepping routine "step" calculates
c      * explicit part of the new velocities
c      * coefficient arrays for iteration of "zetaa"
c      * and implicit part of new velocities
c
c calculate external forcing
c
	call eforce
c
c calculate j+1-values at northernmost latitudes by cross-polar
c averaging
c
	do 10 i=1,lonh
	  u(i,latup) = 0.5*(u(i,latu)-u(i+lonh,latu))
	  v(i,latvp) = 0.5*(v(i,latv)-v(i+lonh,latv))
   10 continue
	do 20 i=lonh+1,longs
	  u(i,latup) = 0.5*(u(i,latu)-u(i-lonh,latu))
	  v(i,latvp) = 0.5*(v(i,latv)-v(i-lonh,latv))
   20 continue
	u(0    ,latup) = u(longs,latup)
	u(longp,latup) = u(1    ,latup)
	v(0    ,latvp) = v(longs,latvp)
	v(longp,latvp) = v(1    ,latvp)
c
c u-section
c
	frus = 0.
	fnls = 0.
	fnln = dy2r
	fxt  = sinu(lafi)*cosur(lafi)
	do 2000 j=lafi,latu
	  fxtq =  (1.+fxt*fxt)*radiur*radiur
	  fruc = -amh*(2.*dxrq*cosur(j)+2.*dyrq+fxtq)
	  fruz =  amh*dxrq*cosur(j)
	  frun =  amh*(dyrq-fxt*dy2r*radiur)
	  fxt2 = -amh*fxt*dxr*radiur
	  fnlz =  dx2r*cosur(j)
	  fxgj =  fxg *cosur(j)
	  do 200 l=1,lseg
	    is = isu(l,j)
	    if(is.eq.0) go to 210
	    ie = ieu(l,j)
c
c depth at u-points
c
	    do 30 i=is,ie
		cfe(i,j) = 0.5*(res(i,j)+res(i+1,j))
   30     continue
c
c v at u-points
c
	    do 40 i=is,ie
		fxn(i,j) = 0.25*((v(i+1,j+1)+v(i,j+1))*gun(j)
     *                     + (v(i+1,j  )+v(i,j  ))*gus(j))
   40     continue
c
c t.r.c. of "u" due to external forces & eddy-viscosity
c
	    do 50 i=is,ie
		ua(i,j) = cfw(i,j) +
     *                  fruc* u(i  ,j  )
     *                + fruz*(u(i-1,j  )+u(i+1,j  ))
     *                + frun* u(i  ,j+1)
     *                + frus* u(i  ,j-1)
     *                + fxt2*(v(i+1,j+1)-v(i  ,j+1))*gun(j)
     *                + fxt2*(v(i+1,j  )-v(i  ,j  ))*gus(j)
   50     continue
c
c t.r.c. of "u" due to advective terms
c
	    do 60 i=is,ie
		ua(i,j) = ua(i,j) -(
     *                u  (i,j)*(u(i+1,j  )-u(i-1,j  ))*fnlz
     *              + fxn(i,j)*(u(i  ,j+1)*fnln
     *                         -u(i  ,j-1)*fnls))
   60     continue
c
c t.r.c. of "u" due to coriolis acceleration
c
	    do 70 i=is,ie
		ua(i,j) = ua(i,j) + fxcs(j)*fxn(i,j)
   70     continue
c
c add t.r.c. due to explicit part of pressure gradient
c and "u" at present time
c
	    do 80 i=is,ie
		ua(i,j) = ua(i,j)*delt+u(i,j)-
     *                fxgj*(zeta(i+1,j)-zeta(i,j))
   80     continue
c
c bottom friction function "fxn"
c
	    do 90 i=is,ie
		fxn(i,j) = u(i,j)*u(i,j) + fxn(i,j)*fxn(i,j)
   90     continue
	    do 100 i=is,ie
		fxn(i,j) = sqrt(fxn(i,j))
  100     continue
	    do 110 i=is,ie
		fxn(i,j) = cfe(i,j)/(cfe(i,j)+frb*fxn(i,j))
  110     continue
c
c multiply explicit part of "ua" by bottom friction function
c
	    do 120 i=is,ie
		ua(i,j) = ua(i,j)*fxn(i,j)
  120     continue
c
c coefficients of implicit pressure gradient
c
	    do 130 i=is,ie
		fxn(i,j) = fxn(i,j)*fxgj
  130     continue
  200   continue
  210   continue
	  fxt  = sinu(j+1)*cosur(j+1)
	  frus = amh*(dyrq+fxt*dy2r*radiur)
	  fnls = dy2r
c
c sum of "u" and "ua" for "rhsi"
c
	  do 220 i=1,longs
	    cfw(i,j) = cfe(i,j)*(u(i,j)+ua(i,j))
  220   continue
c
c cyclic conditions
c
	  cfw(0    ,j) = cfw(longs,j)
 2000 continue
c
c v-section
c
	frvs = 0.
	fnls = 0.
	fyt  = sinv(lafip)*cosvr(lafip)
	do 3000 j=lafip,latv
	  fytq =  (1.+fyt*fyt)*radiur*radiur
	  frvc = -amh*(2.*dxrq*cosvr(j)+2.*dyrq+fytq)
	  frvz =  amh*dxrq*cosvr(j)
	  frvn =  amh*(dyrq-fyt*dy2r*radiur)
	  fyt2 =  amh*fyt*dxr*radiur
	  fnlz =  dx2r*cosvr(j)
	  do 500 l=1,lseg
	    is = isv(l,j)
	    if(is.eq.0) go to 510
	    ie = iev(l,j)
c
c depth at v-points
c
	    do 300 i=is,ie
		cfs(i,j) = 0.5*(gvn(j)*res(i,j)+gvs(j)*res(i,j-1))
  300     continue
c
c u at v-points
c
	    do 310 i=is,ie
		fyn(i,j) = 0.25*((u(i-1,j-1)+u(i,j-1))*gvs(j)
     *                     + (u(i-1,j  )+u(i,j  ))*gvn(j))
  310     continue
c
c t.r.c. of "v" due to external forces & eddy-viscosity
c
	    do 320 i=is,ie
		va(i,j) = cfn(i,j-1) +
     *                  frvc* v(i  ,j  )
     *                + frvz*(v(i-1,j  )+v(i+1,j  ))
     *                + frvn* v(i  ,j+1)
     *                + frvs* v(i  ,j-1)
     *                + fyt2*(u(i  ,j  )-u(i-1,j  ))*gvn(j)
     *                + fyt2*(u(i  ,j-1)-u(i-1,j-1))*gvs(j)
  320     continue
c
c t.r.c. of "v" due to advective terms
c
	    do 330 i=is,ie
		va(i,j) = va(i,j) -(
     *                fyn(i,j)*(v(i+1,j  )-v(i-1,j  ))*fnlz
     *              + v  (i,j)*(v(i  ,j+1)*fnln
     *                         -v(i  ,j-1)*fnls))
  330     continue
c
c t.r.c. of "v" due to coriolis acceleration
c
	    do 340 i=is,ie
		va(i,j) = va(i,j) - fycs(j)*fyn(i,j)
  340     continue
c
c add t.r.c. due to explicit part of pressure gradient
c and "v" at present time
c
	    do 350 i=is,ie
		va(i,j) = va(i,j)*delt+v(i,j)-
     *                fyg*(zeta(i,j)-zeta(i,j-1))
  350     continue
c
c bottom friction function
c
	    do 360 i=is,ie
		fyn(i,j) = v(i,j)*v(i,j) + fyn(i,j)*fyn(i,j)
  360     continue
	    do 370 i=is,ie
		fyn(i,j) = sqrt(fyn(i,j))
  370     continue
	    do 380 i=is,ie
		fyn(i,j) = cfs(i,j)/(cfs(i,j)+frb*fyn(i,j))
  380     continue
c
c multiply "va" by bottom friction function
c
	    do 390 i=is,ie
		va(i,j) = va(i,j)*fyn(i,j)
  390     continue
c
c coefficients of implicit pressure gradient
c
	    do 400 i=is,ie
		fyn(i,j) = fyn(i,j)*fyg
  400     continue
  500   continue
  510   continue
	  fyt  = sinv(j+1)*cosvr(j+1)
	  frvs = amh*(dyrq+fyt*dy2r*radiur)
	  fnls = dy2r
c
c sum of "v" and "va" for "rhsi"
c
	  do 520 i=1,longs
	    cfn(i,j-1) = cfs(i,j)*(v(i,j)+va(i,j))
  520   continue
 3000 continue
c
c inhomogeneous part of the system of iteration-equations
c
	fx   = delt*dx2r
	fy   = delt*dy2r
	fips = 0.
	do 540 j=lafi,latu
	  fipz = fx*cosur(j)
	  fipn = fy*gun  (j)
	  do 530 l=1,lseg
	    is = isz(l,j)
	    if(is.eq.0) go to 535
	    ie = iez(l,j)
	    do 525 i=is,ie
		rhsi(i,j) = zeta(i,j)
     *                + fipz*(cfw(i-1,j)-cfw(i,j))
     *                + fips* cfn(i,j-1)
     *                - fipn* cfn(i,j  )
  525     continue
  530   continue
  535   continue
	  fips = fy*gus(j+1)
  540 continue
	rhsi(1,latz) = 0.
	do 550 i=1,longs
	  rhsi(1,latz) = rhsi(1,latz)+cfn(i,latu)
  550 continue
	rhsi(1,latz) = 0.5*rhsi(1,latz)*pole+zeta(1,latz)
c
c arrays "cxn" and "cyn"
c
	do 560 j=lafi,latu
	  fxx = fx*cosur(j)
	  do 555 i=1,longs
	    cfe(i,j) = fxx*cfe(i,j)*fxn(i,j)
  555   continue
  560 continue
	do 570 j=lafip,latv
	  do 565 i=1,longs
	    cfs(i,j) = fy *cfs(i,j)*fyn(i,j)
  565   continue
  570 continue
c
c coefficients at four sides of any zeta-point
c
	do 580 j=lafi,latu
	  cfe(0    ,j) = cfe(longs,j)
	  do 575 i=1,longs
	    cfw(i,j) = cfe(i-1,j  )
	    cfn(i,j) = cfs(i  ,j+1)*gun(j)
  575   continue
  580 continue
	do 590 j=lafip,latu
	  do 585 i=1,longs
	    cfs(i,j) = cfs(i  ,j  )*gus(j)
  585   continue
  590 continue
c
c special values for northernmost latitude
c
	polfac = pole*dy
	do 600 i=1,longs
	  cfs(i,latz) = cfs(i,latz)*polfac
  600 continue
c
c normalization of coefficient arrays
c
	cennor = 1.
	do 610 i=1,longs
	  cennor = cennor+cfs(i,latz)
	  censou = 1.+cfn(i,lafi)+cfw(i,lafi)+cfe(i,lafi)
	  cfn (i,lafi) = cfn (i,lafi)/censou
	  cfw (i,lafi) = cfw (i,lafi)/censou
	  cfe (i,lafi) = cfe (i,lafi)/censou
	  rhsi(i,lafi) = rhsi(i,lafi)/censou
  610 continue
	rhsi(1,latz) = rhsi(1,latz)/cennor
	cfs (:,latz) = cfs (:,latz)/cennor
	do 620 j=lafip,latu
	  do 615 i=1,longs
	    center = 1.+cfw(i,j)+cfe(i,j)+cfs(i,j)+cfn(i,j)
	    cfw (i,j) = cfw (i,j)/center
	    cfe (i,j) = cfe (i,j)/center
	    cfs (i,j) = cfs (i,j)/center
	    cfn (i,j) = cfn (i,j)/center
	    rhsi(i,j) = rhsi(i,j)/center
  615   continue
  620 continue
c
c calculate elevation
c
	call relax
c
c add implicit pressure gradient
c
	do 630 j=lafi,latu
	  do 625 i=1,longs
	    ua(i,j) = ua (i,j) -
     *              fxn(i,j)*(zetaa(i+1,j)-zetaa(i,j  ))
  625   continue
	  ua(0    ,j) = ua(longs,j)
	  ua(longp,j) = ua(1    ,j)
  630 continue
	do 640 j=lafip,latv
	  do 635 i=1,longs
	    va(i,j) = va (i,j) -
     *              fyn(i,j)*(zetaa(i  ,j)-zetaa(i,j-1))
  635   continue
	  va(0    ,j) = va(longs,j)
	  va(longp,j) = va(1    ,j)
  640 continue
	return
	end
	subroutine relax
	parameter (lafi =1     ,lafip=lafi+1 ,lamz =180    ,
     *           lamv =lamz   ,lamvp=lamv+1 ,lamu =lamz-1 ,
     *           lamup=lamu+1 ,lateu=lamz/2 ,latev=lateu+1,
     *           lseg =22     ,nlove=1      ,longs=360    ,
     *           longp=longs+1,lonh =longs/2,lonv =longs/4,
     *           nener=3      ,nteam=9      ,nteen=4      ,
     *           ntoi =6      ,icomp=3                    )
	common / grid /
     * ncap,latz,latu,latv,latup,latvp,
     * dxdeg,dx,dxr,dx2r,dxrq,dydeg,dy,dyr,dy2r,dyrq,dysdeg,dys,
     * cosu  (lamz),cosv  (lamz),cosur (lamz),cosvr (lamz),
     * sinu  (lamz),sinv  (lamz),fxcs  (lamz),fycs  (lamz),
     * gus   (lamz),gun   (lamz),gvn   (lamz),gvs   (lamz),
     * cosul(longs),sinul(longs),cosvl(longs),sinvl(longs),
     * acsul(longs),asnul(longs),acsvl(longs),asnvl(longs),
     * acc  (longs),ass  (longs),acs  (longs)
	real love(2,nlove)
	common / scalar / delt  ,grav  ,omecor,ometid,phaset,
     *                  amptid,love  ,tlosa ,bofr  ,amh   ,
     *                  crit  ,mxscan,mpscan,fiap  ,resmap,
     *                  itt   ,itsper,itide ,radius,radiur,
     *                  pi    ,zweipi,polar ,pole  ,radian,
     *                  frb   ,fxg   ,fyg
	data love /0.302,0.612/
	common / topogr /
     * isz(lseg,lafi :lamz),iez(lseg,lafi :lamz),
     * isu(lseg,lafi :lamu),ieu(lseg,lafi :lamu),
     * isv(lseg,lafip:lamv),iev(lseg,lafip:lamv),
     * dep(0:longp,lafi:lamz)
	common / fields /
     * zeta(0:longp,lafi:lamz ),
     * u   (0:longp,lafi:lamup),v(0:longp,lafip:lamvp)
	double precision buen  ,baen  ,buamr ,baam  ,chovoi
	double precision buenp ,baenp ,buamrp,baamp ,chovop
	double precision buama ,bumor ,bucom ,butoi
	double precision buamap,bumorp,bucomp,butoip
	common / budget /
     * buen (nener),buenp (nener),baen (nteen),baenp (nteen),
     * buamr(icomp),buamrp(icomp),butoi(ntoi ),butoip(ntoi ),
     * bumor(icomp),bumorp(icomp),bucom(icomp),bucomp(icomp),
     * buama(icomp),buamap(icomp),chovoi,chovop,
     * baam (nteam,icomp),baamp(nteam,icomp)
	common / relcoe / zetaa(0:longp,lafi:lamz),
     *                  cfn  (0:longp,lafi:lamu),
     *                  cfs  (0:longp,lafi:lamz),
     *                  cfe  (0:longp,lafi:lamu),
     *                  cfw  (0:longp,lafi:lamu),
     *                  rhsi (0:longp,lafi:lamz),
     *                  res  (0:longp,lafi:lamz)
c
c "relax" iteratively integrates the sea-surface-elevation.
c
c first guess
c
	zetaa(:,:) = fiap*zeta(:,:)
c
c "mxscan" iterations for the whole domain
c
	do 1000 mscan=1,mxscan
	  do 40 j=lafi,latu
	    do 20 l=1,lseg
		is = isz(l,j)
		if(is.eq.0) go to 30
		ie = iez(l,j)
		do 10 i=is,ie
		  res(i,j) = cfn(i,j)*zetaa(i  ,j+1)
     *                 + cfs(i,j)*zetaa(i  ,j-1)
     *                 + cfe(i,j)*zetaa(i+1,j  )
     *                 + cfw(i,j)*zetaa(i-1,j  )
     *                 - zetaa(i,j)+rhsi(i,j)
   10       continue
   20     continue
   30     continue
	    res(0    ,j) = res(longs,j)
	    res(longp,j) = res(1    ,j)
   40   continue
	  respno = rhsi(1,latz)
	  do 50 i=1,longs
	    respno = respno+cfs(i,latz)*zetaa(i,latu)
   50   continue
	  res  (:,latz) = respno-zetaa(:,latz)
	  do 60 j=lafi,latz
	    zetaa(:,j) = zetaa(:,j)+res(:,j)
   60   continue
 1000 continue
	if(mpscan.le.0) go to 3000
c
c determine area where no further iteration is necessary
c
	jeqs = lafi-1
	do 70 j=lateu,lafi,-1
	  resmas = -99999.
	  do 65 i=1,longs
	    resmas = max(resmas,abs(res(i,j)))
   65   continue
	  if(resmas.ge.crit) then
	    jeqs = j
	    go to 75
	  else
	    resmap = max(resmap,resmas)
	  endif
   70 continue
   75 continue
	msscan = 0
	jeqn = latz+1
	do 85 j=lateu+1,latz
	  resman = -99999.
	  do 80 i=1,longs
	    resman = max(resman,abs(res(i,j)))
   80   continue
	  if(resman.ge.crit) then
	    jeqn = j
	    go to 90
	  else
	    resmap = max(resmap,resman)
	  endif
   85 continue
   90 continue
	mnscan = 0
c
c proceed with further iterations for the southern part
c
 1200 continue
	if(jeqs.lt.lafi) go to 2000
	jeqs   = jeqs+1
	msscan = msscan+1
	do 1300 mscan=1,mxscan
	  do 130 j=lafi,jeqs
	    do 110 l=1,lseg
		is = isz(l,j)
		if(is.eq.0) go to 120
		ie = iez(l,j)
		do 100 i=is,ie
		  res(i,j) = cfn(i,j)*zetaa(i  ,j+1)
     *                 + cfs(i,j)*zetaa(i  ,j-1)
     *                 + cfe(i,j)*zetaa(i+1,j  )
     *                 + cfw(i,j)*zetaa(i-1,j  )
     *                 - zetaa(i,j)+rhsi(i,j)
  100       continue
  110     continue
  120     continue
	    res(0    ,j) = res(longs,j)
	    res(longp,j) = res(1    ,j)
  130   continue
	  do 140 j=lafi,jeqs
	    zetaa(:,j) = zetaa(:,j)+res(:,j)
  140   continue
 1300 continue
	if(msscan.lt.mpscan) then
	  js = lafi-1
	  do 150 j=jeqs,lafi,-1
	    resmas = -99999.
	    do 145 i=1,longs
		resmas = max(resmas,abs(res(i,j)))
  145     continue
	    if(resmas.ge.crit) then
		js = j
		go to 155
	    else
		resmap = max(resmap,resmas)
	    endif
  150   continue
  155   continue
	  jeqs = js
	  go to 1200
	endif
c
c proceed with further iterations for the northern part
c
 2000 continue
	if(jeqn.gt.latz) go to 3000
	mnscan = mnscan+1
	jeqn   = jeqn-1
	do 1500 mscan=1,mxscan
	  do 200 j=jeqn,latu
	    do 180 l=1,lseg
		is = isz(l,j)
		if(is.eq.0) go to 190
		ie = iez(l,j)
		do 170 i=is,ie
		  res(i,j) = cfn(i,j)*zetaa(i  ,j+1)
     *                 + cfs(i,j)*zetaa(i  ,j-1)
     *                 + cfe(i,j)*zetaa(i+1,j  )
     *                 + cfw(i,j)*zetaa(i-1,j  )
     *                 - zetaa(i,j)+rhsi(i,j)
  170       continue
  180     continue
  190     continue
	    res(0    ,j) = res(longs,j)
	    res(longp,j) = res(1    ,j)
  200   continue
	  respno = rhsi(1,latz)
	  do 210 i=1,longs
	    respno = respno+cfs(i,latz)*zetaa(i,latu)
  210   continue
	  res  (:,latz) = respno-zetaa(:,latz)
	  do 220 j=jeqn,latz
	    zetaa(:,j) = zetaa(:,j)+res(:,j)
  220   continue
 1500 continue
	if(mnscan.lt.mpscan) then
	  jn = latz+1
	  do 230 j=jeqn,latz
	    resman = -99999.
	    do 225 i=1,longs
		resman = max(resman,abs(res(i,j)))
  225     continue
	    if(resman.ge.crit) then
		jn = j
		go to 235
	    else
		resmap = max(resmap,resman)
	    endif
  230   continue
  235   continue
	  jeqn = jn
	  go to 2000
	endif
 3000 continue
	return
	end
	subroutine eforce
	parameter (lafi =1     ,lafip=lafi+1 ,lamz =180    ,
     *           lamv =lamz   ,lamvp=lamv+1 ,lamu =lamz-1 ,
     *           lamup=lamu+1 ,lateu=lamz/2 ,latev=lateu+1,
     *           lseg =22     ,nlove=1      ,longs=360    ,
     *           longp=longs+1,lonh =longs/2,lonv =longs/4,
     *           nener=3      ,nteam=9      ,nteen=4      ,
     *           ntoi =6      ,icomp=3                    )
	common / grid /
     * ncap,latz,latu,latv,latup,latvp,
     * dxdeg,dx,dxr,dx2r,dxrq,dydeg,dy,dyr,dy2r,dyrq,dysdeg,dys,
     * cosu  (lamz),cosv  (lamz),cosur (lamz),cosvr (lamz),
     * sinu  (lamz),sinv  (lamz),fxcs  (lamz),fycs  (lamz),
     * gus   (lamz),gun   (lamz),gvn   (lamz),gvs   (lamz),
     * cosul(longs),sinul(longs),cosvl(longs),sinvl(longs),
     * acsul(longs),asnul(longs),acsvl(longs),asnvl(longs),
     * acc  (longs),ass  (longs),acs  (longs)
	real love(2,nlove)
	common / scalar / delt  ,grav  ,omecor,ometid,phaset,
     *                  amptid,love  ,tlosa ,bofr  ,amh   ,
     *                  crit  ,mxscan,mpscan,fiap  ,resmap,
     *                  itt   ,itsper,itide ,radius,radiur,
     *                  pi    ,zweipi,polar ,pole  ,radian,
     *                  frb   ,fxg   ,fyg
	data love /0.302,0.612/
	common / topogr /
     * isz(lseg,lafi :lamz),iez(lseg,lafi :lamz),
     * isu(lseg,lafi :lamu),ieu(lseg,lafi :lamu),
     * isv(lseg,lafip:lamv),iev(lseg,lafip:lamv),
     * dep(0:longp,lafi:lamz)
	common / fields /
     * zeta(0:longp,lafi:lamz ),
     * u   (0:longp,lafi:lamup),v(0:longp,lafip:lamvp)
	double precision buen  ,baen  ,buamr ,baam  ,chovoi
	double precision buenp ,baenp ,buamrp,baamp ,chovop
	double precision buama ,bumor ,bucom ,butoi
	double precision buamap,bumorp,bucomp,butoip
	common / budget /
     * buen (nener),buenp (nener),baen (nteen),baenp (nteen),
     * buamr(icomp),buamrp(icomp),butoi(ntoi ),butoip(ntoi ),
     * bumor(icomp),bumorp(icomp),bucom(icomp),bucomp(icomp),
     * buama(icomp),buamap(icomp),chovoi,chovop,
     * baam (nteam,icomp),baamp(nteam,icomp)
	common / relcoe / zetaa(0:longp,lafi:lamz),
     *                  cfn  (0:longp,lafi:lamu),
     *                  cfs  (0:longp,lafi:lamz),
     *                  cfe  (0:longp,lafi:lamu),
     *                  cfw  (0:longp,lafi:lamu),
     *                  rhsi (0:longp,lafi:lamz),
     *                  res  (0:longp,lafi:lamz)
	common / worksp /
     *  ua (0:longp,lafi:lamu),va (0:longp,lafip:lamv),
     *  fxn(0:longp,lafi:lamu),fyn(0:longp,lafip:lamv)
c
c "eforce" calculates tidal forces, the band being determined by "itide".
c
	cosomt = cos(phaset)
	sinomt = sin(phaset)
	go to (1000,2000,3000) itide
c
c zonal forcing by semi-diurnal tide
c
 2000 continue
	do 20 j=lafi,latu
	  amplit = amptid*cosu(j)
	  do 10 i=1,longs
	    cfw(i,j) = amplit*(sinul(i)*cosomt+cosul(i)*sinomt)
   10   continue
   20 continue
c
c meridional forcing by semi-diurnal tide
c
	do 40 j=lafip,latv
	  amplit = cosv(j)*sinv(j)*amptid
	  do 30 i=1,longs
	    cfn(i,j-1) = amplit*(cosvl(i)*cosomt-sinvl(i)*sinomt)
   30   continue
   40 continue
	return
c
c zonal forcing by diurnal tide
c
 1000 continue
	do 60 j=lafi,latu
	  amplit = amptid*sinu(j)
	  do 50 i=1,longs
	    cfw(i,j) = amplit*(asnul(i)*cosomt+acsul(i)*sinomt)
   50   continue
   60 continue
c
c meridional forcing by diurnal tide
c
	do 80 j=lafip,latv
	  amplit = amptid*(sinv(j)*sinv(j)-cosv(j)*cosv(j))
	  do 70 i=1,longs
	    cfn(i,j-1) = amplit*(acsvl(i)*cosomt-asnvl(i)*sinomt)
   70   continue
   80 continue
	return
c
c forcing by long-period tides
c
 3000 continue
	cfw(:,:) = 0.
	ampt = amptid*cosomt*1.5
	do 100 j=lafip,latv
	  amplit = ampt*cosv(j)*sinv(j)
	  do 90 i=1,longs
	    cfn(i,j-1) = amplit
   90   continue
  100 continue
	return
	end
	subroutine result(iqu)
	parameter (lafi =1     ,lafip=lafi+1 ,lamz =180    ,
     *           lamv =lamz   ,lamvp=lamv+1 ,lamu =lamz-1 ,
     *           lamup=lamu+1 ,lateu=lamz/2 ,latev=lateu+1,
     *           lseg =22     ,nlove=1      ,longs=360    ,
     *           longp=longs+1,lonh =longs/2,lonv =longs/4,
     *           nener=3      ,nteam=9      ,nteen=4      ,
     *           ntoi =6      ,icomp=3                    )
	common / grid /
     * ncap,latz,latu,latv,latup,latvp,
     * dxdeg,dx,dxr,dx2r,dxrq,dydeg,dy,dyr,dy2r,dyrq,dysdeg,dys,
     * cosu  (lamz),cosv  (lamz),cosur (lamz),cosvr (lamz),
     * sinu  (lamz),sinv  (lamz),fxcs  (lamz),fycs  (lamz),
     * gus   (lamz),gun   (lamz),gvn   (lamz),gvs   (lamz),
     * cosul(longs),sinul(longs),cosvl(longs),sinvl(longs),
     * acsul(longs),asnul(longs),acsvl(longs),asnvl(longs),
     * acc  (longs),ass  (longs),acs  (longs)
	real love(2,nlove)
	common / scalar / delt  ,grav  ,omecor,ometid,phaset,
     *                  amptid,love  ,tlosa ,bofr  ,amh   ,
     *                  crit  ,mxscan,mpscan,fiap  ,resmap,
     *                  itt   ,itsper,itide ,radius,radiur,
     *                  pi    ,zweipi,polar ,pole  ,radian,
     *                  frb   ,fxg   ,fyg
	data love /0.302,0.612/
	common / topogr /
     * isz(lseg,lafi :lamz),iez(lseg,lafi :lamz),
     * isu(lseg,lafi :lamu),ieu(lseg,lafi :lamu),
     * isv(lseg,lafip:lamv),iev(lseg,lafip:lamv),
     * dep(0:longp,lafi:lamz)
	common / fields /
     * zeta(0:longp,lafi:lamz ),
     * u   (0:longp,lafi:lamup),v(0:longp,lafip:lamvp)
	double precision buen  ,baen  ,buamr ,baam  ,chovoi
	double precision buenp ,baenp ,buamrp,baamp ,chovop
	double precision buama ,bumor ,bucom ,butoi
	double precision buamap,bumorp,bucomp,butoip
	common / budget /
     * buen (nener),buenp (nener),baen (nteen),baenp (nteen),
     * buamr(icomp),buamrp(icomp),butoi(ntoi ),butoip(ntoi ),
     * bumor(icomp),bumorp(icomp),bucom(icomp),bucomp(icomp),
     * buama(icomp),buamap(icomp),chovoi,chovop,
     * baam (nteam,icomp),baamp(nteam,icomp)
	common / relcoe / zetaa(0:longp,lafi:lamz),
     *                  cfn  (0:longp,lafi:lamu),
     *                  cfs  (0:longp,lafi:lamz),
     *                  cfe  (0:longp,lafi:lamu),
     *                  cfw  (0:longp,lafi:lamu),
     *                  rhsi (0:longp,lafi:lamz),
     *                  res  (0:longp,lafi:lamz)
	common / worksp / zeta1(0:longp,lafi:lamz),
     *                  zeta2(0:longp,lafi:lamz),
     *                  zeta3(0:longp,lafi:lamz)
c
c subroutine to generate arrays of amplitudes and phases of "zeta"
c
	if(iqu.lt.4) then
	  iu = 10+iqu
	  buffer out (iu,1) (zetaa(0,lafi),zetaa(longp,lamz))
	  wsta = unit(iu)
	  rewind iu
	  return
	else
	  buffer in (12,1) (zeta2(0,lafi),zeta2(longp,lamz))
	  buffer in (11,1) (zeta1(0,lafi),zeta1(longp,lamz))
	  buffer in (13,1) (zeta3(0,lafi),zeta3(longp,lamz))
	  wsta = unit(12)
	  zeta2(:,:) = 0.5*(zetaa(:,:)-zeta2(:,:))
	  wsta = unit(11)
	  wsta = unit(13)
	  zeta1(:,:) = 0.5*(zeta1(:,:)-zeta3(:,:))
	  do 30 j=lafi,latu
	    do 20 l=1,lseg
		is = isz(l,j)
		if(is.eq.0) go to 30
		ie = iez(l,j)
		do 10 i=is,ie
**********
		if(zeta1(i,j).ne.0..and.zeta2(i,j).ne.0.)then
		  zeta3(i,j) = atan2(zeta1(i,j),zeta2(i,j))
		else
		  zeta3(i,j) = 0.
		write(6,'(2(2x,i4))') i,j
		endif
**********
   10       continue
		do 15 i=is,ie
		  zeta3(i,j) = zeta3(i,j)-min(0.,sign(zweipi,zeta3(i,j)))
   15       continue
   20     continue
   30   continue
**********
	  if(zeta1(1,latz).ne.0..and.zeta2(1,latz).ne.0.)then
	  phapol = atan2(zeta1(1,latz),zeta2(1,latz))
	  else
	  phapol = 0.
	  write(6,'(2x,f8.3)')phapol
	  endif
**********
	  phapol = phapol-min(0.,sign(zweipi,phapol))
	  do 40 j=latz,lamz
	    do 35 i=0,longp
		zeta3(i,j) = phapol
   35     continue
   40   continue
	  do 50 j=lafi,latz
	    zeta1(:,j) = zeta1(:,j)*zeta1(:,j)
	    zeta2(:,j) = zeta2(:,j)*zeta2(:,j)
   50   continue
	  buffer out (15,1) (zeta3(0,lafi),zeta3(longp,lamz))
	  zeta1(:,:) = zeta1(:,:)+zeta2(:,:)
	  zeta2(:,:) = sqrt(zeta1(:,:))
	  do 60 j=latz+1,lamz
	    zeta2(:,j) = zeta2(0,latz)
   60   continue
	  wsta = unit(15)
	  buffer out (16,1) (zeta2(0,lafi),zeta2(longp,lamz))
	  wsta = unit(16)
	  zeta1(:,:) = 0.
	  zeta2(:,:) = 0.
	  zeta3(:,:) = 0.
	endif
	return
	end
	subroutine diagno(fast)
	parameter (lafi =1     ,lafip=lafi+1 ,lamz =180    ,
     *           lamv =lamz   ,lamvp=lamv+1 ,lamu =lamz-1 ,
     *           lamup=lamu+1 ,lateu=lamz/2 ,latev=lateu+1,
     *           lseg =22     ,nlove=1      ,longs=360    ,
     *           longp=longs+1,lonh =longs/2,lonv =longs/4,
     *           nener=3      ,nteam=9      ,nteen=4      ,
     *           ntoi =6      ,icomp=3                    )
	common / grid /
     * ncap,latz,latu,latv,latup,latvp,
     * dxdeg,dx,dxr,dx2r,dxrq,dydeg,dy,dyr,dy2r,dyrq,dysdeg,dys,
     * cosu  (lamz),cosv  (lamz),cosur (lamz),cosvr (lamz),
     * sinu  (lamz),sinv  (lamz),fxcs  (lamz),fycs  (lamz),
     * gus   (lamz),gun   (lamz),gvn   (lamz),gvs   (lamz),
     * cosul(longs),sinul(longs),cosvl(longs),sinvl(longs),
     * acsul(longs),asnul(longs),acsvl(longs),asnvl(longs),
     * acc  (longs),ass  (longs),acs  (longs)
	real love(2,nlove)
	common / scalar / delt  ,grav  ,omecor,ometid,phaset,
     *                  amptid,love  ,tlosa ,bofr  ,amh   ,
     *                  crit  ,mxscan,mpscan,fiap  ,resmap,
     *                  itt   ,itsper,itide ,radius,radiur,
     *                  pi    ,zweipi,polar ,pole  ,radian,
     *                  frb   ,fxg   ,fyg
	data love /0.302,0.612/
	common / topogr /
     * isz(lseg,lafi :lamz),iez(lseg,lafi :lamz),
     * isu(lseg,lafi :lamu),ieu(lseg,lafi :lamu),
     * isv(lseg,lafip:lamv),iev(lseg,lafip:lamv),
     * dep(0:longp,lafi:lamz)
	common / fields /
     * zeta(0:longp,lafi:lamz ),
     * u   (0:longp,lafi:lamup),v(0:longp,lafip:lamvp)
	double precision buen  ,baen  ,buamr ,baam  ,chovoi
	double precision buenp ,baenp ,buamrp,baamp ,chovop
	double precision buama ,bumor ,bucom ,butoi
	double precision buamap,bumorp,bucomp,butoip
	common / budget /
     * buen (nener),buenp (nener),baen (nteen),baenp (nteen),
     * buamr(icomp),buamrp(icomp),butoi(ntoi ),butoip(ntoi ),
     * bumor(icomp),bumorp(icomp),bucom(icomp),bucomp(icomp),
     * buama(icomp),buamap(icomp),chovoi,chovop,
     * baam (nteam,icomp),baamp(nteam,icomp)
	common / relcoe / zetaa(0:longp,lafi:lamz),
     *                  cfn  (0:longp,lafi:lamu),
     *                  cfs  (0:longp,lafi:lamz),
     *                  cfe  (0:longp,lafi:lamu),
     *                  cfw  (0:longp,lafi:lamu),
     *                  rhsi (0:longp,lafi:lamz),
     *                  res  (0:longp,lafi:lamz)
	common / worksp /
     *  ua (0:longp,lafi:lamu),va (0:longp,lafip:lamv),
     *  fxn(0:longp,lafi:lamu),fyn(0:longp,lafip:lamv)
	logical fast
	dimension wor(11)
c
c "diagno" calculates surface integrals of instantaneous
c   *  kinetic   energy   on buen(1)
c   *  potential energy   on buen(2)
c   *  total     energy   on buen(3)
c   *  angular momentum due to relative motion on buamr
c   *  tensor of inertia                       on butoi
c   *  total angular momentum                  on buama
c   *  momentum due to relative motion         on bumor
c   *  position of the center of mass          on bucom
c
CDIR$ SHORTLOOP
	buen (:) = 0.d0
CDIR$ SHORTLOOP
	buamr(:) = 0.d0
	boxar    = dx*dy
	fke      = boxar*0.25
	fpe      = 0.5*grav
	famr     = boxar*0.5*radius
	ftoi     = radius*radius
	fcom     = radius/5.977e+27
	fmor     = 0.5*boxar
	zpol     = zetaa(1,latz)
	zzpol    = zpol*zpol
	spol     = sinu(latz)
	sspol    = spol*spol
c
c volume conservation error & potential energy
c
	chovoi = 0.
	do 20 j=lafi,latu
	  wor(1) = 0.
	  wor(2) = 0.
	  do 10 i=1,longs
	    wor(1) = wor(1)+zetaa(i,j)
	    wor(2) = wor(2)+zetaa(i,j)*zetaa(i,j)
   10   continue
	  chovoi  = chovoi +wor(1)*cosu(j)
	  buen(2) = buen(2)+wor(2)*cosu(j)
   20 continue
	chovoi  = chovoi*boxar+zpol*polar
	chovop  = chovop+chovoi
	buen(2) = (buen(2)*boxar+zzpol*polar)*fpe
c
c kinetic energy and relative angular momentum
c
	do 50 j=lafi,latu
	  wor(1:4) = 0.
	  do 30 i=1,longs
	    cfw(i,j  ) = ua(i,j  )*(res(i,j)+res(i+1,j))
	    cfs(i,j+1) = va(i,j+1)*(cosu(j+1)*res(i,j+1)
     *                           +cosu(j  )*res(i,j  ))
   30   continue
	  do 40 i=1,longs
	    wor  (1) = wor  (1)+cfw(i,j  )*ua   (i,j  )
	    wor  (2) = wor  (2)-cfw(i,j  )*acsul(i    )
	    wor  (3) = wor  (3)-cfw(i,j  )*asnul(i    )
	    wor  (4) = wor  (4)+cfw(i,j  )
	    buen (1) = buen (1)+cfs(i,j+1)*va   (i,j+1)
	    buamr(1) = buamr(1)+cfs(i,j+1)*asnvl(i    )
	    buamr(2) = buamr(2)-cfs(i,j+1)*acsvl(i    )
   40   continue
	  wor(1:4) = wor(1:4)*cosu(j)
	  buen (1) = buen (1)+wor(1)
	  buamr(1) = buamr(1)+wor(2)*sinu(j)
	  buamr(2) = buamr(2)+wor(3)*sinu(j)
	  buamr(3) = buamr(3)+wor(4)*cosu(j)
   50 continue
c
c area factor
c
	buen (1) = fke    *buen (1)
	buen (3) = buen(1)+buen (2)
CDIR$ SHORTLOOP
	buamr(:) = famr   *buamr(:)
c
c time integral
c
CDIR$ SHORTLOOP
	buenp (:) = buenp (:)+buen (:)
CDIR$ SHORTLOOP
	buamrp(:) = buamrp(:)+buamr(:)
	if(fast) return
c
c additional bulk quantities
c
CDIR$ SHORTLOOP
	butoi(:) = 0.d0
CDIR$ SHORTLOOP
	bumor(:) = 0.d0
CDIR$ SHORTLOOP
	bucom(:) = 0.d0
CDIR$ SHORTLOOP
	buama(:) = 0.d0
	do 80 j=lafi,latu
	  wor(:) = 0.
	  fcc    = cosu(j)*cosu(j)
	  fss    = 1.-fcc
	  do 70 i=1,longs
	    wor( 1) = wor( 1)+zetaa(i,j  )
	    wor( 2) = wor( 2)+zetaa(i,j  )*acsvl(i)
	    wor( 3) = wor( 3)+zetaa(i,j  )*asnvl(i)
	    wor( 4) = wor( 4)+zetaa(i,j  )*ass  (i)
	    wor( 5) = wor( 5)+zetaa(i,j  )*acc  (i)
	    wor( 6) = wor( 6)-zetaa(i,j  )*acs  (i)
	    wor( 7) = wor( 7)-cfw  (i,j  )*asnul(i)
	    wor( 8) = wor( 8)+cfw  (i,j  )*acsul(i)
	    wor( 9) = wor( 9)-cfs  (i,j+1)*acsvl(i)
	    wor(10) = wor(10)-cfs  (i,j+1)*asnvl(i)
	    wor(11) = wor(11)+cfs  (i,j+1)
   70   continue
	  wor(1:8) = wor(1:8)*cosu(j)
	  bucom(1) = bucom(1)+wor( 2)*cosu(j  )
	  bucom(2) = bucom(2)+wor( 3)*cosu(j  )
	  bucom(3) = bucom(3)+wor( 1)*sinu(j  )
	  bumor(1) = bumor(1)+wor( 9)*sinv(j+1)+wor(7)
	  bumor(2) = bumor(2)+wor(10)*sinv(j+1)+wor(8)
	  bumor(3) = bumor(3)+wor(11)*cosv(j+1)
	  butoi(1) = butoi(1)+wor( 4)*fcc      +wor(1)*fss
	  butoi(2) = butoi(2)+wor( 5)*fcc      +wor(1)*fss
	  butoi(3) = butoi(3)+wor( 1)*fcc
	  butoi(4) = butoi(4)+wor( 6)*fcc
	  butoi(5) = butoi(5)-wor( 2)*sinu(j  )*cosu(j)
	  butoi(6) = butoi(6)-wor( 3)*sinu(j  )*cosu(j)
   80 continue
c
c area factor and contributions from polar cap
c
	butoi(1) = ftoi*(butoi(1)*boxar+zpol*sspol*polar)
	butoi(2) = ftoi*(butoi(2)*boxar+zpol*sspol*polar)
	butoi(3) = ftoi* butoi(3)*boxar
	butoi(4) = ftoi* butoi(4)*boxar
	butoi(5) = ftoi* butoi(5)*boxar
	butoi(6) = ftoi* butoi(6)*boxar
	bucom(1) = fcom* bucom(1)*boxar
	bucom(2) = fcom* bucom(2)*boxar
	bucom(3) = fcom*(bucom(3)*boxar+zpol* spol*polar)
	buama(1) =      -butoi(5)*omecor*0.5
	buama(2) =      -butoi(6)*omecor*0.5
	buama(3) =       butoi(3)*omecor*0.5
CDIR$ SHORTLOOP
	bumor(:) = bumor(:)*fmor
c
c time integral
c
CDIR$ SHORTLOOP
	butoip(:) = butoip(:)+butoi(:)
CDIR$ SHORTLOOP
	buamap(:) = buamap(:)+buama(:)
CDIR$ SHORTLOOP
	bucomp(:) = bucomp(:)+bucom(:)
CDIR$ SHORTLOOP
	bumorp(:) = bumorp(:)+bumor(:)
	return
	end
	subroutine bilanz
	parameter (lafi =1     ,lafip=lafi+1 ,lamz =180    ,
     *           lamv =lamz   ,lamvp=lamv+1 ,lamu =lamz-1 ,
     *           lamup=lamu+1 ,lateu=lamz/2 ,latev=lateu+1,
     *           lseg =22     ,nlove=1      ,longs=360    ,
     *           longp=longs+1,lonh =longs/2,lonv =longs/4,
     *           nener=3      ,nteam=9      ,nteen=4      ,
     *           ntoi =6      ,icomp=3                    )
	common / grid /
     * ncap,latz,latu,latv,latup,latvp,
     * dxdeg,dx,dxr,dx2r,dxrq,dydeg,dy,dyr,dy2r,dyrq,dysdeg,dys,
     * cosu  (lamz),cosv  (lamz),cosur (lamz),cosvr (lamz),
     * sinu  (lamz),sinv  (lamz),fxcs  (lamz),fycs  (lamz),
     * gus   (lamz),gun   (lamz),gvn   (lamz),gvs   (lamz),
     * cosul(longs),sinul(longs),cosvl(longs),sinvl(longs),
     * acsul(longs),asnul(longs),acsvl(longs),asnvl(longs),
     * acc  (longs),ass  (longs),acs  (longs)
	real love(2,nlove)
	common / scalar / delt  ,grav  ,omecor,ometid,phaset,
     *                  amptid,love  ,tlosa ,bofr  ,amh   ,
     *                  crit  ,mxscan,mpscan,fiap  ,resmap,
     *                  itt   ,itsper,itide ,radius,radiur,
     *                  pi    ,zweipi,polar ,pole  ,radian,
     *                  frb   ,fxg   ,fyg
	data love /0.302,0.612/
	common / topogr /
     * isz(lseg,lafi :lamz),iez(lseg,lafi :lamz),
     * isu(lseg,lafi :lamu),ieu(lseg,lafi :lamu),
     * isv(lseg,lafip:lamv),iev(lseg,lafip:lamv),
     * dep(0:longp,lafi:lamz)
	common / fields /
     * zeta(0:longp,lafi:lamz ),
     * u   (0:longp,lafi:lamup),v(0:longp,lafip:lamvp)
	double precision buen  ,baen  ,buamr ,baam  ,chovoi
	double precision buenp ,baenp ,buamrp,baamp ,chovop
	double precision buama ,bumor ,bucom ,butoi
	double precision buamap,bumorp,bucomp,butoip
	common / budget /
     * buen (nener),buenp (nener),baen (nteen),baenp (nteen),
     * buamr(icomp),buamrp(icomp),butoi(ntoi ),butoip(ntoi ),
     * bumor(icomp),bumorp(icomp),bucom(icomp),bucomp(icomp),
     * buama(icomp),buamap(icomp),chovoi,chovop,
     * baam (nteam,icomp),baamp(nteam,icomp)
	common / relcoe / zetaa(0:longp,lafi:lamz),
     *                  cfn  (0:longp,lafi:lamu),
     *                  cfs  (0:longp,lafi:lamz),
     *                  cfe  (0:longp,lafi:lamu),
     *                  cfw  (0:longp,lafi:lamu),
     *                  rhsi (0:longp,lafi:lamz),
     *                  res  (0:longp,lafi:lamz)
	common / worksp /
     *  ua (0:longp,lafi:lamu),va (0:longp,lafip:lamv),
     *  fxn(0:longp,lafi:lamu),fyn(0:longp,lafip:lamv)
	dimension waam(nteam,icomp),waen(nteen)
c
c "bilanz" calculates the following contributions to energy- and
c angular momentum-balances as volume-integrals:
c    * baen(n,lg), n=1-5 contains instantaneous work by
c                  bottom     friction     (n=1)
c                  horizontal friction     (n=2)
c                  tidal forces            (n=3)
c                  perturbation potentials (n=4)
c    * baenp contains the corresponding temporal means
c
c    * baam(n,k,lg), n=1-9,k=1-3 contains t.r.c. of angular momentum by
c                  acceleration (rel,tot)  (n=1)
c                  coriolis                (n=2)
c                  acceleration (abs,tot)  (n=3)
c                  pressure forces         (n=4)
c                  tidal forces (primary)  (n=5)
c                  tidal forces (total)    (n=6)
c                  bottom     friction     (n=7)
c                  horizontal friction     (n=8)
c                  total friction          (n=9)
c
c    * baamp contains the corresponding temporal means
c
CDIR$ SHORTLOOP
	baam(:,:) = 0.d0
CDIR$ SHORTLOOP
	baen(:  ) = 0.d0
c
c sum of old and new elevation
c
	do 10 j=lafi,latz
	  rhsi(:,j) = zeta(:,j)+zetaa(:,j)
   10 continue
c
c tidal forces
c
	call eforce
c
c contribution by zonal forces
c
	fxt  = sinu(lafi)*cosur(lafi)
	frus = 0.
	fnls = 0.
	fnln = dy2r
	do 1000 j=lafi,latu
	  waam(:,:) = 0.
	  waen(:  ) = 0.
	  fxtq =  (1.+fxt*fxt)*radiur*radiur
	  fruc = -2.*dxrq*cosur(j)-2.*dyrq-fxtq
	  fruz =  dxrq*cosur(j)
	  frun =  dyrq-fxt*dy2r*radiur
	  fxt2 = -fxt*dxr*radiur
	  fnlz =  dx2r*cosur(j)
	  fxgr =  grav*dx2r*cosur(j)
	  do 500 l=1,lseg
	    is = isu(l,j)
	    if(is.eq.0) go to 600
	    ie = ieu(l,j)
c
c depth at u-points
c
	    do 100 i=is,ie
		cfe(i,j) = (res(i,j)+res(i+1,j))*0.5
  100     continue
c
c v at u-points
c
	    do 110 i=is,ie
		fxn(i,j) = 0.25*((v(i+1,j+1)+v(i,j+1))*gun(j)
     *                     + (v(i+1,j  )+v(i,j  ))*gus(j))
  110     continue
c
c torque and work of body forces
c
	    do 120 i=is,ie
		cfw(i,j)  = cfw(i,j)*cfe(i,j)
		waen(3  ) = waen(3  )+cfw(i,j)*u(i,j)
		waam(5,1) = waam(5,1)-cfw(i,j)*acsul(i)
		waam(5,2) = waam(5,2)-cfw(i,j)*asnul(i)
		waam(5,3) = waam(5,3)+cfw(i,j)
*2105
c170100	  write(44,'(2i3,f8.4)') i,j,cfw(i,j)
*2105
  120     continue
c
c t.r.c. of relative angular momentum
c
	    do 130 i=is,ie
		cfw(i,j)  = cfe(i,j)*((ua(i ,j  )-u(i  ,j  ))/delt
     *                  +  u(i,j)*(u(i+1,j  )-u(i-1,j  ))*fnlz
     *                  +fxn(i,j)*(u(i  ,j+1)*fnln
     *                            -u(i  ,j-1)*fnls      )     )
		waam(1,1) = waam(1,1)-cfw(i,j)*acsul(i)
		waam(1,2) = waam(1,2)-cfw(i,j)*asnul(i)
		waam(1,3) = waam(1,3)+cfw(i,j)
  130     continue
c
c omega-momentum
c
	    do 140 i=is,ie
		cfw(i,j)  = -fxn(i,j)*cfe(i,j)
		waam(2,1) = waam(2,1)-cfw(i,j)*acsul(i)
		waam(2,2) = waam(2,2)-cfw(i,j)*asnul(i)
		waam(2,3) = waam(2,3)+cfw(i,j)
  140     continue
c
c pressure torque and perturbation potentials
c
	    do 150 i=is,ie
		cfw(i,j)  = (rhsi(i,j)-rhsi(i+1,j))*cfe(i,j)
		waen(4  ) = waen(4  )+cfw(i,j)*u(i,j)
		waam(4,1) = waam(4,1)-cfw(i,j)*acsul(i)
		waam(4,2) = waam(4,2)-cfw(i,j)*asnul(i)
		waam(4,3) = waam(4,3)+cfw(i,j)
  150     continue
c
c dissipation by eddy-viscosity
c
	    do 160 i=is,ie
		cfw(i,j)  = (fruc* u(i  ,j  )
     *                  +fruz*(u(i-1,j  )+u(i+1,j  ))
     *                  +frun* u(i  ,j+1)
     *                  +frus* u(i  ,j-1)
     *                  +fxt2*(v(i+1,j+1)-v(i  ,j+1))*gun(j)
     *                  +fxt2*(v(i+1,j  )-v(i  ,j  ))*gus(j))*cfe(i,j)
		waen (2  )= waen(2  )+cfw(i,j)*u(i,j)
		waam (8,1)= waam(8,1)-cfw(i,j)*acsul(i)
		waam (8,2)= waam(8,2)-cfw(i,j)*asnul(i)
		waam (8,3)= waam(8,3)+cfw(i,j)
  160     continue
c
c dissipation by bottom friction
c
	    do 170 i=is,ie
		fxn(i,j) = u(i,j)*u(i,j) + fxn(i,j)*fxn(i,j)
  170     continue
	    do 180 i=is,ie
		cfw(i,j)  = -sqrt(fxn(i,j))*ua(i,j)
		waen(1  ) = waen(1  )+cfw(i,j)*u(i,j)
		waam(7,1) = waam(7,1)-cfw(i,j)*acsul(i)
		waam(7,2) = waam(7,2)-cfw(i,j)*asnul(i)
		waam(7,3) = waam(7,3)+cfw(i,j)
  180     continue
  500   continue
  600   continue
	  waam(2,:  ) = waam(2,:  )*fxcs(j)
	  waam(4,:  ) = waam(4,:  )*fxgr
	  waen(4    ) = waen(4    )*fxgr
	  baen(:    ) = baen(:    )+waen(:    )*cosu(j)
	  waam(:,:  ) = waam(:,:  )*cosu(j)
	  baam(:,1:2) = baam(:,1:2)+waam(:,1:2)*sinu(j)
	  baam(:,3  ) = baam(:,3  )+waam(:,3  )*cosu(j)
	  fxt  = sinu(j+1)*cosur(j+1)
	  frus = dyrq+fxt*dy2r*radiur
	  fnls = dy2r
 1000 continue
c
c contributions by meridional field of motion
c
	fyt  = sinv(lafip)*cosvr(lafip)
	frvs = 0.
	fnls = 0.
	fygr = grav*dy2r
	do 2000 j=lafip,latv
	  waam(:,1:2) = 0.
	  waen(:    ) = 0.
	  fytq =  (1.+fyt*fyt)*radiur*radiur
	  frvc = -2.*dxrq*cosvr(j)-2.*dyrq-fytq
	  frvz =  dxrq*cosvr(j)
	  frvn =  dyrq-fyt*dy2r*radiur
	  fyt2 =  fyt*dxr*radiur
	  fnlz =  dx2r*cosvr(j)
	  do 1500 l=1,lseg
	    is = isv(l,j)
	    if(is.eq.0) go to 1600
	    ie = iev(l,j)
c
c depth at v-points
c
	    do 200 i=is,ie
		cfs(i,j) = (gvn(j)*res(i,j)+gvs(j)*res(i,j-1))*0.5
  200     continue
c
c u at v-points
c
	    do 210 i=is,ie
		fyn(i,j) = 0.25*((u(i-1,j-1)+u(i,j-1))*gvs(j)
     *                     + (u(i-1,j  )+u(i,j  ))*gvn(j))
  210     continue
c
c torque and work of body forces
c
	    do 220 i=is,ie
		cfw(i,j)  = cfn(i,j-1)*cfs(i,j)
		waen(3  ) = waen(3  )+cfw(i,j)*v(i,j)
		waam(5,1) = waam(5,1)+cfw(i,j)*asnvl(i)
		waam(5,2) = waam(5,2)-cfw(i,j)*acsvl(i)
  220     continue
c
c t.r.c. of relative angular momentum
c
	    do 230 i=is,ie
		cfw(i,j)  = cfs(i,j)*((va(i ,j  )-v(i  ,j  ))/delt
     *                  +fyn(i,j)*(v(i+1,j  )-v(i-1,j  ))*fnlz
     *                  +v  (i,j)*(v(i  ,j+1)*fnln
     *                           - v(i  ,j-1)*fnls      )     )
		waam(1,1) = waam(1,1)+cfw(i,j)*asnvl(i)
		waam(1,2) = waam(1,2)-cfw(i,j)*acsvl(i)
  230     continue
c
c omega-momentum
c
	    do 240 i=is,ie
		cfw(i,j)  = fyn(i,j)*cfs(i,j)
		waam(2,1) = waam(2,1)+cfw(i,j)*asnvl(i)
		waam(2,2) = waam(2,2)-cfw(i,j)*acsvl(i)
  240     continue
c
c pressure torque and perturbation potentials
c
	    do 250 i=is,ie
		cfw(i,j ) = (rhsi(i,j-1)-rhsi(i,j))*cfs(i,j)
		waen(4  ) = waen(4  )+cfw(i,j)*v(i,j)
		waam(4,1) = waam(4,1)+cfw(i,j)*asnvl(i)
		waam(4,2) = waam(4,2)-cfw(i,j)*acsvl(i)
  250     continue
c
c dissipation by eddy-viscosity
c
	    do 260 i=is,ie
		cfw(i,j)  = (frvc* v(i  ,j  )
     *                  +frvz*(v(i-1,j  )+v(i+1,j  ))
     *                  +frvn* v(i  ,j+1)
     *                  +frvs* v(i  ,j-1)
     *                  +fyt2*(u(i  ,j  )-u(i-1,j  ))*gvn(j)
     *                  +fyt2*(u(i  ,j-1)-u(i-1,j-1))*gvs(j))*cfs(i,j)
		waen(2  ) = waen(2  )+cfw(i,j)*v(i,j)
		waam(8,1) = waam(8,1)+cfw(i,j)*asnvl(i)
		waam(8,2) = waam(8,2)-cfw(i,j)*acsvl(i)
  260     continue
c
c dissipation by bottom friction
c
	    do 270 i=is,ie
		fyn(i,j) = v(i,j)*v(i,j) + fyn(i,j)*fyn(i,j)
  270     continue
	    do 280 i=is,ie
		cfw(i,j)  = -sqrt(fyn(i,j))*va(i,j)
		waen(1  ) = waen(1  )+cfw(i,j)*v(i,j)
		waam(7,1) = waam(7,1)+cfw(i,j)*asnvl(i)
		waam(7,2) = waam(7,2)-cfw(i,j)*acsvl(i)
  280     continue
 1500   continue
 1600   continue
	  waam(2,1:2) = waam(2,1:2)*fycs(j)
	  waam(4,1:2) = waam(4,1:2)*fygr
	  waen(4    ) = waen(4    )*fygr
	  baen(:    ) = baen(:    )+waen(:    )*cosv(j)
	  baam(:,1:2) = baam(:,1:2)+waam(:,1:2)*cosv(j)
	  fyt  = sinv(j+1)*cosvr(j+1)
	  frvs = dyrq+fyt*dy2r*radiur
	  fnls = dy2r
 2000 continue
c
c correction of terms
c
c *** bottom friction
c
	  baen(1  ) = baen(1  )*bofr
	  baam(7,1) = baam(7,1)*bofr
	  baam(7,2) = baam(7,2)*bofr
	  baam(7,3) = baam(7,3)*bofr
c
c *** eddy viscosity
c
	  baen(2  ) = baen(2  )*amh
	  baam(8,1) = baam(8,1)*amh
	  baam(8,2) = baam(8,2)*amh
	  baam(8,3) = baam(8,3)*amh
c
c *** total frictional torque
c
	  baam(9,1) = baam(8,1)+baam (7,1)
	  baam(9,2) = baam(8,2)+baam (7,2)
	  baam(9,3) = baam(8,3)+baam (7,3)
c
c *** total tidal torque
c
	  baen(4  ) = -baen(4  )*tlosa
	  baam(6,1) =  baam(5,1)-baam (4,1)*tlosa
	  baam(6,2) =  baam(5,2)-baam (4,2)*tlosa
	  baam(6,3) =  baam(5,3)-baam (4,3)*tlosa
c
c *** t.r.c. of total angular momentum
c
	  baam(3,1) = baam(1,1)+baam (2,1)
	  baam(3,2) = baam(1,2)+baam (2,2)
	  baam(3,3) = baam(1,3)+baam (2,3)
c
c area factor & time integral
c
CDIR$ SHORTLOOP
	  baen (:) = baen (:)*dx*dy
CDIR$ SHORTLOOP
	  baenp(:) = baenp(:)+baen(:)
CDIR$ SHORTLOOP
	  baam (:,:) = baam (:,:)*dx*dy*radius
CDIR$ SHORTLOOP
	  baamp(:,:) = baamp(:,:)+baam(:,:)
	return
	end
	subroutine todisk
	parameter (lafi =1     ,lafip=lafi+1 ,lamz =180    ,
     *           lamv =lamz   ,lamvp=lamv+1 ,lamu =lamz-1 ,
     *           lamup=lamu+1 ,lateu=lamz/2 ,latev=lateu+1,
     *           lseg =22     ,nlove=1      ,longs=360    ,
     *           longp=longs+1,lonh =longs/2,lonv =longs/4,
     *           nener=3      ,nteam=9      ,nteen=4      ,
     *           ntoi =6      ,icomp=3                    )
	real love(2,nlove)
	common / scalar / delt  ,grav  ,omecor,ometid,phaset,
     *                  amptid,love  ,tlosa ,bofr  ,amh   ,
     *                  crit  ,mxscan,mpscan,fiap  ,resmap,
     *                  itt   ,itsper,itide ,radius,radiur,
     *                  pi    ,zweipi,polar ,pole  ,radian,
     *                  frb   ,fxg   ,fyg
	data love /0.302,0.612/
	common / relcoe / zetaa(0:longp,lafi:lamz)
	common / worksp /
     *  ua(0:longp,lafi:lamu),va(0:longp,lafip:lamv)
c
c perform buffered output on a storage period
c
	buffer out(31,0) (zetaa(0,lafi ),zetaa(longp,lamz))
	buffer out(32,0) (ua   (0,lafi ),ua   (longp,lamu))
	buffer out(33,0) (va   (0,lafip),va   (longp,lamv))
	wstaz = unit(31)
	wstau = unit(32)
	wstav = unit(33)
	write(6,1010) itt,wstaz,wstau,wstav
	return
 1010 format(' itt=',i5,' wstaz=',f4.1,' wstau=',f4.1,
     *                  ' wstav=',f4.1)
	end
c
